--[[ Air Strike airplane image
script by Kiffer-Opa
version 1.2
 
Licence: what licence? Do whatever you want!
]]

asimg = {}

-- PARAMETERS: feel free to change these for your purpose
asimg.speed = 10		-- pixels the air plane moves per frame (50 ms)
asimg.start = 2500		-- pixels the airplane is away from the player when the Air Strike is thrown
-- END OF PARAMETERS

asimg.weapons = {}
asimg.planes = {}

addhook("always","asimg.moveplanes",5)
addhook("attack","asimg.attack",5)

function asimg.moveplanes()
	local steplength = asimg.speed

	for n=#asimg.planes, 1, -1 do
		if(asimg.planes[n]~=nil) then
			asimg.planes[n].position.x = asimg.planes[n].position.x + (math.sin(math.rad(asimg.planes[n].rot))*steplength)
			asimg.planes[n].position.y = asimg.planes[n].position.y - (math.cos(math.rad(asimg.planes[n].rot))*steplength)
			
			asimg.planes[n].traveled = asimg.planes[n].traveled + steplength
			
			imagepos(asimg.planes[n].imgid, asimg.planes[n].position.x, asimg.planes[n].position.y, asimg.planes[n].rot)
			
			if(asimg.planes[n].traveled >= asimg.start*2) then
				freeimage(asimg.planes[n].imgid)
				table.remove(asimg.planes, n)
			end
		end
	end
	
	local players=player(0,"table")
	for i=1,32 do
		if(player(i,"exists")) then
			asimg.weapons[players[i]] = player(i,"weapontype")
		end
	end
end


function asimg.attack(playerID)
	local weapon = asimg.weapons[playerID]
	if(weapon==76) then	-- 	76==Air Strike
		local x = player(playerID,"x")
		local y = player(playerID,"y")
		local rot = player(playerID,"rot")
		local plane = {}	
		plane.rot = rot
		plane.traveled = 0
		
		plane.position = {}
		plane.position.x = x - (math.sin(math.rad(plane.rot))*asimg.start)
		plane.position.y = y + (math.cos(math.rad(plane.rot))*asimg.start)
		
		plane.imgid = image("gfx/Boing_B_17G_contour.png",plane.position.x ,plane.position.y,1)
		
		imagepos(plane.imgid, plane.position.x, plane.position.y, plane.rot)
		imagescale(plane.imgid, 1, 1)
		imagecolor(plane.imgid, 0, 0, 0)
		imagealpha(plane.imgid, 0.3)
		
		table.insert(asimg.planes, plane)
		asimg.weapons[playerID] = nil
	end
end

